#include "eanim.h"

unsigned char *dechunkify(int w, int h, int x, int y, void *chk, int csize)
{
   int            xx,yy,x2,y2,i,j;
   unsigned char  *data;
   int            shift;
   RawChunk24_8   *c8;
   RawChunk24_16  *c16;
   RawChunk24_32  *c32;
   RawChunk24_64  *c64;
   RawChunk24_128 *c128;

   data=(unsigned char *)malloc(w*h*3);if (!data) return NULL;
   i=0;j=0;
   if      (csize==8)   c8=(RawChunk24_8 *)chk;
   else if (csize==16)  c16=(RawChunk24_16 *)chk;
   else if (csize==32)  c32=(RawChunk24_32 *)chk;
   else if (csize==64)  c64=(RawChunk24_64 *)chk;
   else if (csize==128) c128=(RawChunk24_128 *)chk;
   if      (csize==8)   shift=3;
   else if (csize==16)  shift=4;
   else if (csize==32)  shift=5;
   else if (csize==64)  shift=6;
   else if (csize==128) shift=7;
   for(yy=0;yy<y;yy++)
     {
	for(y2=0;y2<csize;y2++)
	  {
	     if (((yy<<shift)+y2)<h)
	       {
		  for(xx=0;xx<x;xx++)
		    {
		       i=(yy*x)+xx;
		       for(x2=0;x2<csize;x2++)
			 {
			    if (((xx<<shift)+x2)<w)
			      {
				 if      (csize==8)   
				   {
				      data[j++]=c8[i].p[x2][y2].r;
				      data[j++]=c8[i].p[x2][y2].g;
				      data[j++]=c8[i].p[x2][y2].b;
				   }
				 else if (csize==16)  
				   {
				      data[j++]=c16[i].p[x2][y2].r;
				      data[j++]=c16[i].p[x2][y2].g;
				      data[j++]=c16[i].p[x2][y2].b;
				   }
				 else if (csize==32)  
				   {
				      data[j++]=c32[i].p[x2][y2].r;
				      data[j++]=c32[i].p[x2][y2].g;
				      data[j++]=c32[i].p[x2][y2].b;
				   }
				 else if (csize==64)  
				   {
				      data[j++]=c64[i].p[x2][y2].r;
				      data[j++]=c64[i].p[x2][y2].g;
				      data[j++]=c64[i].p[x2][y2].b;
				   }
				 else if (csize==128) 
				   {
				      data[j++]=c128[i].p[x2][y2].r;
				      data[j++]=c128[i].p[x2][y2].g;
				      data[j++]=c128[i].p[x2][y2].b;
				   }
			      }
			 }
		    }
	       }
	  }
     }
   return data;
}

void *chunkify(int w, int h, unsigned char *data, int *x, int *y, int csize)
{
   int xx,yy,i,cnum;
   int shift; 
   RawChunk24_8   *c8;
   RawChunk24_16  *c16;
   RawChunk24_32  *c32;
   RawChunk24_64  *c64;
   RawChunk24_128 *c128;
  
   if      (csize==8)   shift=3;
   else if (csize==16)  shift=4;
   else if (csize==32)  shift=5;
   else if (csize==64)  shift=6;
   else if (csize==128) shift=7;
   *x=w>>shift;if (w&(csize-1)) *x++;
   *y=h>>shift;if (h&(csize-1)) *y++;
   if      (csize==8)   
     {
	c8=(RawChunk24_8 *)malloc(sizeof(RawChunk24_8)**x**y);if (!c8) return NULL;
     }
   else if (csize==16)   
     {
	c16=(RawChunk24_16 *)malloc(sizeof(RawChunk24_16)**x**y);if (!c16) return NULL;
     }
   else if (csize==32)   
     {
	c32=(RawChunk24_32 *)malloc(sizeof(RawChunk24_32)**x**y);if (!c32) return NULL;
     }
   else if (csize==64)   
     {
	c64=(RawChunk24_64 *)malloc(sizeof(RawChunk24_64)**x**y);if (!c64) return NULL;
     }
   else if (csize==128)   
     {
	c128=(RawChunk24_128 *)malloc(sizeof(RawChunk24_128)**x**y);if (!c128) return NULL;
     }
   i=0;
   if (data)
     {
	for (yy=0;yy<h;yy++)
	  {
	     for (xx=0;xx<w;xx++)
	       {
		  cnum=((yy>>shift)**x)+(xx>>shift);
		  if      (csize==8)   
		    {
		       c8[cnum].p[xx&(csize-1)][yy&(csize-1)].r=data[i++];
		       c8[cnum].p[xx&(csize-1)][yy&(csize-1)].g=data[i++];
		       c8[cnum].p[xx&(csize-1)][yy&(csize-1)].b=data[i++];
		    }
		  else if (csize==16)   
		    {
		       c16[cnum].p[xx&(csize-1)][yy&(csize-1)].r=data[i++];
		       c16[cnum].p[xx&(csize-1)][yy&(csize-1)].g=data[i++];
		       c16[cnum].p[xx&(csize-1)][yy&(csize-1)].b=data[i++];
		    }
		  else if (csize==32)   
		    {
		       c32[cnum].p[xx&(csize-1)][yy&(csize-1)].r=data[i++];
		       c32[cnum].p[xx&(csize-1)][yy&(csize-1)].g=data[i++];
		       c32[cnum].p[xx&(csize-1)][yy&(csize-1)].b=data[i++];
		    }
		  else if (csize==64)   
		    {
		       c64[cnum].p[xx&(csize-1)][yy&(csize-1)].r=data[i++];
		       c64[cnum].p[xx&(csize-1)][yy&(csize-1)].g=data[i++];
		       c64[cnum].p[xx&(csize-1)][yy&(csize-1)].b=data[i++];
		    }
		  else if (csize==128)   
		    {
		       c128[cnum].p[xx&(csize-1)][yy&(csize-1)].r=data[i++];
		       c128[cnum].p[xx&(csize-1)][yy&(csize-1)].g=data[i++];
		       c128[cnum].p[xx&(csize-1)][yy&(csize-1)].b=data[i++];
		    }
	       }
	  }
     }
   else
     {
	if      (csize==8)   memset(c8,0,sizeof(RawChunk24_8)**x**y);
	else if (csize==16)  memset(c16,0,sizeof(RawChunk24_16)**x**y);
	else if (csize==32)  memset(c32,0,sizeof(RawChunk24_32)**x**y);
	else if (csize==64)  memset(c64,0,sizeof(RawChunk24_64)**x**y);
	else if (csize==128) memset(c128,0,sizeof(RawChunk24_128)**x**y);
     }
   if      (csize==8)   return (void *)c8;
   else if (csize==16)  return (void *)c16;
   else if (csize==32)  return (void *)c32;
   else if (csize==64)  return (void *)c64;
   else if (csize==128) return (void *)c128;
}

void decode_pixel(int code, Pixel24 *p, int pix)
{
   unsigned int r,g,b;
   
   switch (code)
     {
      case FLAG_PIX_24b:
	r=(pix>>16)&0xff;
	g=(pix>>8)&0xff;
	b=(pix)&0xff;
	break;
      case FLAG_PIX_16b:
	r=(pix>>8)&0xf8;
	g=(pix>>3)&0xfc;
	b=(pix<<3)&0xf8;
	break;
      case FLAG_PIX_332:
	r=(pix)&0xe0;
	g=(pix<<3)&0xe0;
	b=(pix<<6)&0xc0;
	break;
      case FLAG_PIX_R:
	r=pix;
	g=0;
	b=0;
	break;
      case FLAG_PIX_G:
	r=0;
	g=pix;
	b=0;
	break;
      case FLAG_PIX_B:
	r=0;
	g=0;
	b=pix;
	break;
      case FLAG_PIX_RG:
	r=(pix>>8);
	g=pix&0xff;
	b=0;
	break;
      case FLAG_PIX_RB:
	r=(pix>>8);
	g=0;
	b=pix&0xff;
	break;
      case FLAG_PIX_GB:
	r=0;
	g=(pix>>8);
	b=pix&0xff;
	break;
      case FLAG_PIX_RG8:
	r=pix&0xf0;
	g=(pix<<4)&0xf0;
	b=0;
	break;
      case FLAG_PIX_RB8:
	r=pix&0xf0;
	g=0;
	b=(pix<<4)&0xf0;
	break;
      case FLAG_PIX_GB8:
	r=0;
	g=pix&0xf0;
	b=(pix<<4)&0xf0;
	break;
      case FLAG_PIX_GRY:
	r=pix;
	g=pix;
	b=pix;
	break;
      case FLAG_PIX_422:
	r=pix&0xf0;
	g=(pix<<4)&0xc0;
	b=(pix<<6)&0xc0;
	break;
      case FLAG_PIX_242:
	r=pix&0xc0;
	g=(pix<<2)&0xf0;
	b=(pix<<6)&0xc0;
	break;
      case FLAG_PIX_224:
	r=pix&0xc0;
	g=(pix<<2)&0xc0;
	b=(pix<<4)&0xf0;
	break;
      default:
	break;
     }
   p->r=(unsigned char)r;
   p->g=(unsigned char)g;
   p->b=(unsigned char)b;
}

int encode_pixel(int code, Pixel24 *p)
{
   int pix;
   
   pix=0;
   switch (code)
     {
      case FLAG_PIX_24b:
	pix=(((unsigned int)p->r<<16)&0xff0000)|
	  (((unsigned int)p->g<<8)&0x00ff00)|
	  (((unsigned int)p->b)&0x0000ff);
	break;
      case FLAG_PIX_16b:
	pix=(((unsigned int)p->r<<8)&0xf800)|
	  (((unsigned int)p->g<<3)&0x07e0)|
	  (((unsigned int)p->b>>3)&0x001f);
	break;
      case FLAG_PIX_332:
	pix=(((unsigned int)p->r)&0xe0)|
	  (((unsigned int)p->g>>3)&0x1c)|
	  (((unsigned int)p->b>>6)&0x03);
	break;
      case FLAG_PIX_R:
	pix=(unsigned int)p->r;
	break;
      case FLAG_PIX_G:
	pix=(unsigned int)p->g;
	break;
      case FLAG_PIX_B:
	pix=(unsigned int)p->b;
	break;
      case FLAG_PIX_RG:
	pix=(((unsigned int)p->r<<8)&0xff00)|
	  (((unsigned int)p->g)&0xff);
	break;
      case FLAG_PIX_RB:
	pix=(((unsigned int)p->r<<8)&0xff00)|
	  (((unsigned int)p->b)&0xff);
	break;
      case FLAG_PIX_GB:
	pix=(((unsigned int)p->g<<8)&0xff00)|
	  (((unsigned int)p->b)&0xff);
	break;
      case FLAG_PIX_RG8:
	pix=(((unsigned int)p->r)&0xf0)|
	  (((unsigned int)p->g>>4)&0x0f);
	break;
      case FLAG_PIX_RB8:
	pix=(((unsigned int)p->r)&0xf0)|
	  (((unsigned int)p->b>>4)&0x0f);
	break;
      case FLAG_PIX_GB8:
	pix=(((unsigned int)p->g)&0xf0)|
	  (((unsigned int)p->b>>4)&0x0f);
	break;
      case FLAG_PIX_GRY:
	pix=((((unsigned int)p->r))+
	  (((unsigned int)p->g))+
	  (((unsigned int)p->b)))/3;
	break;
      case FLAG_PIX_422:
	pix=(((unsigned int)p->r)&0xf0)|
	  (((unsigned int)p->g>>4)&0x0c)|
	  (((unsigned int)p->b>>6)&0x03);
	break;
      case FLAG_PIX_242:
	pix=(((unsigned int)p->r)&0xc0)|
	  (((unsigned int)p->g>>2)&0x3c)|
	  (((unsigned int)p->b>>6)&0x03);
	break;
      case FLAG_PIX_224:
	pix=(((unsigned int)p->r)&0xc0)|
	  (((unsigned int)p->g>>2)&0x30)|
	  (((unsigned int)p->b>>4)&0x0f);
	break;
      default:
	break;
     }
   return pix;
}

int encode_loss(int code, int pix, Pixel24 *p)
{
   unsigned int r,g,b;
   int loss;
   
   switch (code)
     {
      case FLAG_PIX_24b:
	r=(pix>>16)&0xff;
	g=(pix>>8)&0xff;
	b=(pix)&0xff;
	break;
      case FLAG_PIX_16b:
	r=(pix>>8)&0xf8;
	g=(pix>>3)&0xfc;
	b=(pix<<3)&0xf8;
	break;
      case FLAG_PIX_332:
	r=(pix)&0xe0;
	g=(pix<<3)&0xe0;
	b=(pix<<6)&0xc0;
	break;
      case FLAG_PIX_R:
	r=pix;
	g=0;
	b=0;
	break;
      case FLAG_PIX_G:
	r=0;
	g=pix;
	b=0;
	break;
      case FLAG_PIX_B:
	r=0;
	g=0;
	b=pix;
	break;
      case FLAG_PIX_RG:
	r=(pix>>8);
	g=pix&0xff;
	b=0;
	break;
      case FLAG_PIX_RB:
	r=(pix>>8);
	g=0;
	b=pix&0xff;
	break;
      case FLAG_PIX_GB:
	r=0;
	g=(pix>>8);
	b=pix&0xff;
	break;
      case FLAG_PIX_RG8:
	r=pix&0xf0;
	g=(pix<<4)&0xf0;
	b=0;
	break;
      case FLAG_PIX_RB8:
	r=pix&0xf0;
	g=0;
	b=(pix<<4)&0xf0;
	break;
      case FLAG_PIX_GB8:
	r=0;
	g=pix&0xf0;
	b=(pix<<4)&0xf0;
	break;
      case FLAG_PIX_GRY:
	r=pix;
	g=pix;
	b=pix;
	break;
      case FLAG_PIX_422:
	r=pix&0xf0;
	g=(pix<<4)&0xc0;
	b=(pix<<6)&0xc0;
	break;
      case FLAG_PIX_242:
	r=pix&0xc0;
	g=(pix<<2)&0xf0;
	b=(pix<<6)&0xc0;
	break;
      case FLAG_PIX_224:
	r=pix&0xc0;
	g=(pix<<2)&0xc0;
	b=(pix<<4)&0xf0;
	break;
      default:
	break;
     }
   if (p->r>r) r=p->r-r;
   else r=r-p->r;
   if (p->g>g) g=p->g-g;
   else g=g-p->g;
   if (p->b>b) b=p->b-b;
   else b=b-p->b;
   loss=r+g+b;
   return loss;
}

void decode_chunk(int code_type, void *data, void *chk, int csize)
{
   Pixel24 p;
   int bpp,x,y,xx,yy,res,i,code;
   unsigned int pix;
   unsigned char *byte;
   unsigned short *word;
   int shift; 
   RawChunk24_8   *c8;
   RawChunk24_16  *c16;
   RawChunk24_32  *c32;
   RawChunk24_64  *c64;
   RawChunk24_128 *c128;
   
   if      (csize==8)   c8=(RawChunk24_8 *)chk;
   else if (csize==16)  c16=(RawChunk24_16 *)chk;
   else if (csize==32)  c32=(RawChunk24_32 *)chk;
   else if (csize==64)  c64=(RawChunk24_64 *)chk;
   else if (csize==128) c128=(RawChunk24_128 *)chk;
   if      (csize==8)   shift=3;
   else if (csize==16)  shift=4;
   else if (csize==32)  shift=5;
   else if (csize==64)  shift=6;
   else if (csize==128) shift=7;

   res=code_type&FLAG_RES_MSK;code=code_type&FLAG_PIX_MSK;
   if (code==FLAG_PIX_24b) bpp=3;
   else if ((code==FLAG_PIX_16b)||(code==FLAG_PIX_RG)||
	    (code==FLAG_PIX_RB)||(code==FLAG_PIX_GB)) bpp=2;
   else        bpp=1;
   if (bpp==2) word=(unsigned short *)data;
   else        byte=(unsigned char *)data;
   i=0;
   if (csize==8)
     {
	switch(res)
	  {
	   case FLAG_RES_8x8:
	     for (y=0;y<csize;y++)
	       {
		  for(x=0;x<csize;x++)
		    {
		       if (code==FLAG_PIX_24b) 
			 {
			    pix=(unsigned int)byte[i++]<<16;
			    pix|=(unsigned int)byte[i++]<<8;
			    pix|=(unsigned int)byte[i++];
			 }
		       else if ((code==FLAG_PIX_16b)||(code==FLAG_PIX_RG)||
				(code==FLAG_PIX_RB)||(code==FLAG_PIX_GB))
			 pix=(unsigned int)word[i++];
		       else
			 pix=(unsigned int)byte[i++];
		       decode_pixel(code,&p,pix);	
		       c8->p[x][y].r=p.r;c8->p[x][y].g=p.g;c8->p[x][y].b=p.b;
		    }
	       }
	     break;
	   case FLAG_RES_4x4:
	     for (y=0;y<csize>>1;y++)
	       {
		  for(x=0;x<csize>>1;x++)
		    {
		       if (code==FLAG_PIX_24b) 
			 {
			    pix=(unsigned int)byte[i++]<<16;
			    pix|=(unsigned int)byte[i++]<<8;
			    pix|=(unsigned int)byte[i++];
			 }
		       else if ((code==FLAG_PIX_16b)||(code==FLAG_PIX_RG)||
				(code==FLAG_PIX_RB)||(code==FLAG_PIX_GB))
			 pix=(unsigned int)word[i++];
		       else
			 pix=(unsigned int)byte[i++];
		       decode_pixel(code,&p,pix);
		       for(yy=0;yy<2;yy++)
			 {
			    for(xx=0;xx<2;xx++)
			      {
				 c8->p[(x<<1)+xx][(y<<1)+yy].r=p.r;
				 c8->p[(x<<1)+xx][(y<<1)+yy].g=p.g;
				 c8->p[(x<<1)+xx][(y<<1)+yy].b=p.b;
			      }
			 }
		    }
	       }
	     break;
	   case FLAG_RES_2x2:
	     for (y=0;y<csize>>2;y++)
	       {
		  for(x=0;x<csize>>2;x++)
		    {
		       if (code==FLAG_PIX_24b) 
			 {
			    pix=(unsigned int)byte[i++]<<16;
			    pix|=(unsigned int)byte[i++]<<8;
			    pix|=(unsigned int)byte[i++];
			 }
		       else if ((code==FLAG_PIX_16b)||(code==FLAG_PIX_RG)||
				(code==FLAG_PIX_RB)||(code==FLAG_PIX_GB))
			 pix=(unsigned int)word[i++];
		       else
			 pix=(unsigned int)byte[i++];
		       decode_pixel(code,&p,pix);
		       for(yy=0;yy<4;yy++)
			 {
			    for(xx=0;xx<4;xx++)
			      {
				 c8->p[(x<<2)+xx][(y<<2)+yy].r=p.r;
				 c8->p[(x<<2)+xx][(y<<2)+yy].g=p.g;
				 c8->p[(x<<2)+xx][(y<<2)+yy].b=p.b;
			      }
			 }
		    }
	       }
	     break;
	   case FLAG_RES_1x1:
	     for (y=0;y<csize>>3;y++)
	       {
		  for(x=0;x<csize>>3;x++)
		    {
		       if (code==FLAG_PIX_24b) 
			 {
			    pix=(unsigned int)byte[i++]<<16;
			    pix|=(unsigned int)byte[i++]<<8;
			    pix|=(unsigned int)byte[i++];
			 }
		       else if ((code==FLAG_PIX_16b)||(code==FLAG_PIX_RG)||
				(code==FLAG_PIX_RB)||(code==FLAG_PIX_GB))
			 pix=(unsigned int)word[i++];
		       else
			 pix=(unsigned int)byte[i++];
		       decode_pixel(code,&p,pix);
		       for(yy=0;yy<8;yy++)
			 {
			    for(xx=0;xx<8;xx++)
			      {
				 c8->p[(x<<3)+xx][(y<<3)+yy].r=p.r;
				 c8->p[(x<<3)+xx][(y<<3)+yy].g=p.g;
				 c8->p[(x<<3)+xx][(y<<3)+yy].b=p.b;
			      }
			 }
		    }
	       }
	     break;
	   default:
	     break;
	  }
     }
   else if (csize==16)
     {
	switch(res)
	  {
	   case FLAG_RES_16x16:
	     for (y=0;y<csize;y++)
	       {
		  for(x=0;x<csize;x++)
		    {
		       if (code==FLAG_PIX_24b) 
			 {
			    pix=(unsigned int)byte[i++]<<16;
			    pix|=(unsigned int)byte[i++]<<8;
			    pix|=(unsigned int)byte[i++];
			 }
		       else if ((code==FLAG_PIX_16b)||(code==FLAG_PIX_RG)||
				(code==FLAG_PIX_RB)||(code==FLAG_PIX_GB))
			 pix=(unsigned int)word[i++];
		       else
			 pix=(unsigned int)byte[i++];
		       decode_pixel(code,&p,pix);	
		       c16->p[x][y].r=p.r;c16->p[x][y].g=p.g;c16->p[x][y].b=p.b;
		    }
	       }
	     break;
	   case FLAG_RES_8x8:
	     for (y=0;y<csize>>1;y++)
	       {
		  for(x=0;x<csize>>1;x++)
		    {
		       if (code==FLAG_PIX_24b) 
			 {
			    pix=(unsigned int)byte[i++]<<16;
			    pix|=(unsigned int)byte[i++]<<8;
			    pix|=(unsigned int)byte[i++];
			 }
		       else if ((code==FLAG_PIX_16b)||(code==FLAG_PIX_RG)||
				(code==FLAG_PIX_RB)||(code==FLAG_PIX_GB))
			 pix=(unsigned int)word[i++];
		       else
			 pix=(unsigned int)byte[i++];
		       decode_pixel(code,&p,pix);
		       for(yy=0;yy<2;yy++)
			 {
			    for(xx=0;xx<2;xx++)
			      {
				 c16->p[(x<<1)+xx][(y<<1)+yy].r=p.r;
				 c16->p[(x<<1)+xx][(y<<1)+yy].g=p.g;
				 c16->p[(x<<1)+xx][(y<<1)+yy].b=p.b;
			      }
			 }
		    }
	       }
	     break;
	   case FLAG_RES_4x4:
	     for (y=0;y<csize>>2;y++)
	       {
		  for(x=0;x<csize>>2;x++)
		    {
		       if (code==FLAG_PIX_24b) 
			 {
			    pix=(unsigned int)byte[i++]<<16;
			    pix|=(unsigned int)byte[i++]<<8;
			    pix|=(unsigned int)byte[i++];
			 }
		       else if ((code==FLAG_PIX_16b)||(code==FLAG_PIX_RG)||
				(code==FLAG_PIX_RB)||(code==FLAG_PIX_GB))
			 pix=(unsigned int)word[i++];
		       else
			 pix=(unsigned int)byte[i++];
		       decode_pixel(code,&p,pix);
		       for(yy=0;yy<4;yy++)
			 {
			    for(xx=0;xx<4;xx++)
			      {
				 c16->p[(x<<2)+xx][(y<<2)+yy].r=p.r;
				 c16->p[(x<<2)+xx][(y<<2)+yy].g=p.g;
				 c16->p[(x<<2)+xx][(y<<2)+yy].b=p.b;
			      }
			 }
		    }
	       }
	     break;
	   case FLAG_RES_2x2:
	     for (y=0;y<csize>>3;y++)
	       {
		  for(x=0;x<csize>>3;x++)
		    {
		       if (code==FLAG_PIX_24b) 
			 {
			    pix=(unsigned int)byte[i++]<<16;
			    pix|=(unsigned int)byte[i++]<<8;
			    pix|=(unsigned int)byte[i++];
			 }
		       else if ((code==FLAG_PIX_16b)||(code==FLAG_PIX_RG)||
				(code==FLAG_PIX_RB)||(code==FLAG_PIX_GB))
			 pix=(unsigned int)word[i++];
		       else
			 pix=(unsigned int)byte[i++];
		       decode_pixel(code,&p,pix);
		       for(yy=0;yy<8;yy++)
			 {
			    for(xx=0;xx<8;xx++)
			      {
				 c16->p[(x<<3)+xx][(y<<3)+yy].r=p.r;
				 c16->p[(x<<3)+xx][(y<<3)+yy].g=p.g;
				 c16->p[(x<<3)+xx][(y<<3)+yy].b=p.b;
			      }
			 }
		    }
	       }
	     break;
	   case FLAG_RES_1x1:
	     for (y=0;y<csize>>4;y++)
	       {
		  for(x=0;x<csize>>4;x++)
		    {
		       if (code==FLAG_PIX_24b) 
			 {
			    pix=(unsigned int)byte[i++]<<16;
			    pix|=(unsigned int)byte[i++]<<8;
			    pix|=(unsigned int)byte[i++];
			 }
		       else if ((code==FLAG_PIX_16b)||(code==FLAG_PIX_RG)||
				(code==FLAG_PIX_RB)||(code==FLAG_PIX_GB))
			 pix=(unsigned int)word[i++];
		       else
			 pix=(unsigned int)byte[i++];
		       decode_pixel(code,&p,pix);
		       for(yy=0;yy<16;yy++)
			 {
			    for(xx=0;xx<16;xx++)
			      {
				 c16->p[(x<<4)+xx][(y<<4)+yy].r=p.r;
				 c16->p[(x<<4)+xx][(y<<4)+yy].g=p.g;
				 c16->p[(x<<4)+xx][(y<<4)+yy].b=p.b;
			      }
			 }
		    }
	       }
	     break;
	   default:
	     break;
	  }
     }
   else if (csize==32)
     {
	switch(res)
	  {
	   case FLAG_RES_32x32:
	     for (y=0;y<csize;y++)
	       {
		  for(x=0;x<csize;x++)
		    {
		       if (code==FLAG_PIX_24b) 
			 {
			    pix=(unsigned int)byte[i++]<<16;
			    pix|=(unsigned int)byte[i++]<<8;
			    pix|=(unsigned int)byte[i++];
			 }
		       else if ((code==FLAG_PIX_16b)||(code==FLAG_PIX_RG)||
				(code==FLAG_PIX_RB)||(code==FLAG_PIX_GB))
			 pix=(unsigned int)word[i++];
		       else
			 pix=(unsigned int)byte[i++];
		       decode_pixel(code,&p,pix);	
		       c32->p[x][y].r=p.r;c32->p[x][y].g=p.g;c32->p[x][y].b=p.b;
		    }
	       }
	     break;
	   case FLAG_RES_16x16:
	     for (y=0;y<csize>>1;y++)
	       {
		  for(x=0;x<csize>>1;x++)
		    {
		       if (code==FLAG_PIX_24b) 
			 {
			    pix=(unsigned int)byte[i++]<<16;
			    pix|=(unsigned int)byte[i++]<<8;
			    pix|=(unsigned int)byte[i++];
			 }
		       else if ((code==FLAG_PIX_16b)||(code==FLAG_PIX_RG)||
				(code==FLAG_PIX_RB)||(code==FLAG_PIX_GB))
			 pix=(unsigned int)word[i++];
		       else
			 pix=(unsigned int)byte[i++];
		       decode_pixel(code,&p,pix);
		       for(yy=0;yy<2;yy++)
			 {
			    for(xx=0;xx<2;xx++)
			      {
				 c32->p[(x<<1)+xx][(y<<1)+yy].r=p.r;
				 c32->p[(x<<1)+xx][(y<<1)+yy].g=p.g;
				 c32->p[(x<<1)+xx][(y<<1)+yy].b=p.b;
			      }
			 }
		    }
	       }
	     break;
	   case FLAG_RES_8x8:
	     for (y=0;y<csize>>2;y++)
	       {
		  for(x=0;x<csize>>2;x++)
		    {
		       if (code==FLAG_PIX_24b) 
			 {
			    pix=(unsigned int)byte[i++]<<16;
			    pix|=(unsigned int)byte[i++]<<8;
			    pix|=(unsigned int)byte[i++];
			 }
		       else if ((code==FLAG_PIX_16b)||(code==FLAG_PIX_RG)||
				(code==FLAG_PIX_RB)||(code==FLAG_PIX_GB))
			 pix=(unsigned int)word[i++];
		       else
			 pix=(unsigned int)byte[i++];
		       decode_pixel(code,&p,pix);
		       for(yy=0;yy<4;yy++)
			 {
			    for(xx=0;xx<4;xx++)
			      {
				 c32->p[(x<<2)+xx][(y<<2)+yy].r=p.r;
				 c32->p[(x<<2)+xx][(y<<2)+yy].g=p.g;
				 c32->p[(x<<2)+xx][(y<<2)+yy].b=p.b;
			      }
			 }
		    }
	       }
	     break;
	   case FLAG_RES_4x4:
	     for (y=0;y<csize>>3;y++)
	       {
		  for(x=0;x<csize>>3;x++)
		    {
		       if (code==FLAG_PIX_24b) 
			 {
			    pix=(unsigned int)byte[i++]<<16;
			    pix|=(unsigned int)byte[i++]<<8;
			    pix|=(unsigned int)byte[i++];
			 }
		       else if ((code==FLAG_PIX_16b)||(code==FLAG_PIX_RG)||
				(code==FLAG_PIX_RB)||(code==FLAG_PIX_GB))
			 pix=(unsigned int)word[i++];
		       else
			 pix=(unsigned int)byte[i++];
		       decode_pixel(code,&p,pix);
		       for(yy=0;yy<8;yy++)
			 {
			    for(xx=0;xx<8;xx++)
			      {
				 c32->p[(x<<3)+xx][(y<<3)+yy].r=p.r;
				 c32->p[(x<<3)+xx][(y<<3)+yy].g=p.g;
				 c32->p[(x<<3)+xx][(y<<3)+yy].b=p.b;
			      }
			 }
		    }
	       }
	     break;
	   case FLAG_RES_2x2:
	     for (y=0;y<csize>>4;y++)
	       {
		  for(x=0;x<csize>>4;x++)
		    {
		       if (code==FLAG_PIX_24b) 
			 {
			    pix=(unsigned int)byte[i++]<<16;
			    pix|=(unsigned int)byte[i++]<<8;
			    pix|=(unsigned int)byte[i++];
			 }
		       else if ((code==FLAG_PIX_16b)||(code==FLAG_PIX_RG)||
				(code==FLAG_PIX_RB)||(code==FLAG_PIX_GB))
			 pix=(unsigned int)word[i++];
		       else
			 pix=(unsigned int)byte[i++];
		       decode_pixel(code,&p,pix);
		       for(yy=0;yy<16;yy++)
			 {
			    for(xx=0;xx<16;xx++)
			      {
				 c32->p[(x<<4)+xx][(y<<4)+yy].r=p.r;
				 c32->p[(x<<4)+xx][(y<<4)+yy].g=p.g;
				 c32->p[(x<<4)+xx][(y<<4)+yy].b=p.b;
			      }
			 }
		    }
	       }
	     break;
	   case FLAG_RES_1x1:
	     for (y=0;y<csize>>5;y++)
	       {
		  for(x=0;x<csize>>5;x++)
		    {
		       if (code==FLAG_PIX_24b) 
			 {
			    pix=(unsigned int)byte[i++]<<16;
			    pix|=(unsigned int)byte[i++]<<8;
			    pix|=(unsigned int)byte[i++];
			 }
		       else if ((code==FLAG_PIX_16b)||(code==FLAG_PIX_RG)||
				(code==FLAG_PIX_RB)||(code==FLAG_PIX_GB))
			 pix=(unsigned int)word[i++];
		       else
			 pix=(unsigned int)byte[i++];
		       decode_pixel(code,&p,pix);
		       for(yy=0;yy<32;yy++)
			 {
			    for(xx=0;xx<32;xx++)
			      {
				 c32->p[(x<<5)+xx][(y<<5)+yy].r=p.r;
				 c32->p[(x<<5)+xx][(y<<5)+yy].g=p.g;
				 c32->p[(x<<5)+xx][(y<<5)+yy].b=p.b;
			      }
			 }
		    }
	       }
	     break;
	   default:
	     break;
	  }
     }
   else if (csize==64)
     {
	switch(res)
	  {
	   case FLAG_RES_64x64:
	     for (y=0;y<csize;y++)
	       {
		  for(x=0;x<csize;x++)
		    {
		       if (code==FLAG_PIX_24b) 
			 {
			    pix=(unsigned int)byte[i++]<<16;
			    pix|=(unsigned int)byte[i++]<<8;
			    pix|=(unsigned int)byte[i++];
			 }
		       else if ((code==FLAG_PIX_16b)||(code==FLAG_PIX_RG)||
				(code==FLAG_PIX_RB)||(code==FLAG_PIX_GB))
			 pix=(unsigned int)word[i++];
		       else
			 pix=(unsigned int)byte[i++];
		       decode_pixel(code,&p,pix);	
		       c64->p[x][y].r=p.r;c64->p[x][y].g=p.g;c64->p[x][y].b=p.b;
		    }
	       }
	     break;
	   case FLAG_RES_32x32:
	     for (y=0;y<csize>>1;y++)
	       {
		  for(x=0;x<csize>>1;x++)
		    {
		       if (code==FLAG_PIX_24b) 
			 {
			    pix=(unsigned int)byte[i++]<<16;
			    pix|=(unsigned int)byte[i++]<<8;
			    pix|=(unsigned int)byte[i++];
			 }
		       else if ((code==FLAG_PIX_16b)||(code==FLAG_PIX_RG)||
				(code==FLAG_PIX_RB)||(code==FLAG_PIX_GB))
			 pix=(unsigned int)word[i++];
		       else
			 pix=(unsigned int)byte[i++];
		       decode_pixel(code,&p,pix);
		       for(yy=0;yy<2;yy++)
			 {
			    for(xx=0;xx<2;xx++)
			      {
				 c64->p[(x<<1)+xx][(y<<1)+yy].r=p.r;
				 c64->p[(x<<1)+xx][(y<<1)+yy].g=p.g;
				 c64->p[(x<<1)+xx][(y<<1)+yy].b=p.b;
			      }
			 }
		    }
	       }
	     break;
	   case FLAG_RES_16x16:
	     for (y=0;y<csize>>2;y++)
	       {
		  for(x=0;x<csize>>2;x++)
		    {
		       if (code==FLAG_PIX_24b) 
			 {
			    pix=(unsigned int)byte[i++]<<16;
			    pix|=(unsigned int)byte[i++]<<8;
			    pix|=(unsigned int)byte[i++];
			 }
		       else if ((code==FLAG_PIX_16b)||(code==FLAG_PIX_RG)||
				(code==FLAG_PIX_RB)||(code==FLAG_PIX_GB))
			 pix=(unsigned int)word[i++];
		       else
			 pix=(unsigned int)byte[i++];
		       decode_pixel(code,&p,pix);
		       for(yy=0;yy<4;yy++)
			 {
			    for(xx=0;xx<4;xx++)
			      {
				 c64->p[(x<<2)+xx][(y<<2)+yy].r=p.r;
				 c64->p[(x<<2)+xx][(y<<2)+yy].g=p.g;
				 c64->p[(x<<2)+xx][(y<<2)+yy].b=p.b;
			      }
			 }
		    }
	       }
	     break;
	   case FLAG_RES_8x8:
	     for (y=0;y<csize>>3;y++)
	       {
		  for(x=0;x<csize>>3;x++)
		    {
		       if (code==FLAG_PIX_24b) 
			 {
			    pix=(unsigned int)byte[i++]<<16;
			    pix|=(unsigned int)byte[i++]<<8;
			    pix|=(unsigned int)byte[i++];
			 }
		       else if ((code==FLAG_PIX_16b)||(code==FLAG_PIX_RG)||
				(code==FLAG_PIX_RB)||(code==FLAG_PIX_GB))
			 pix=(unsigned int)word[i++];
		       else
			 pix=(unsigned int)byte[i++];
		       decode_pixel(code,&p,pix);
		       for(yy=0;yy<8;yy++)
			 {
			    for(xx=0;xx<8;xx++)
			      {
				 c64->p[(x<<3)+xx][(y<<3)+yy].r=p.r;
				 c64->p[(x<<3)+xx][(y<<3)+yy].g=p.g;
				 c64->p[(x<<3)+xx][(y<<3)+yy].b=p.b;
			      }
			 }
		    }
	       }
	     break;
	   case FLAG_RES_4x4:
	     for (y=0;y<csize>>4;y++)
	       {
		  for(x=0;x<csize>>4;x++)
		    {
		       if (code==FLAG_PIX_24b) 
			 {
			    pix=(unsigned int)byte[i++]<<16;
			    pix|=(unsigned int)byte[i++]<<8;
			    pix|=(unsigned int)byte[i++];
			 }
		       else if ((code==FLAG_PIX_16b)||(code==FLAG_PIX_RG)||
				(code==FLAG_PIX_RB)||(code==FLAG_PIX_GB))
			 pix=(unsigned int)word[i++];
		       else
			 pix=(unsigned int)byte[i++];
		       decode_pixel(code,&p,pix);
		       for(yy=0;yy<16;yy++)
			 {
			    for(xx=0;xx<16;xx++)
			      {
				 c64->p[(x<<4)+xx][(y<<4)+yy].r=p.r;
				 c64->p[(x<<4)+xx][(y<<4)+yy].g=p.g;
				 c64->p[(x<<4)+xx][(y<<4)+yy].b=p.b;
			      }
			 }
		    }
	       }
	     break;
	   case FLAG_RES_2x2:
	     for (y=0;y<csize>>5;y++)
	       {
		  for(x=0;x<csize>>5;x++)
		    {
		       if (code==FLAG_PIX_24b) 
			 {
			    pix=(unsigned int)byte[i++]<<16;
			    pix|=(unsigned int)byte[i++]<<8;
			    pix|=(unsigned int)byte[i++];
			 }
		       else if ((code==FLAG_PIX_16b)||(code==FLAG_PIX_RG)||
				(code==FLAG_PIX_RB)||(code==FLAG_PIX_GB))
			 pix=(unsigned int)word[i++];
		       else
			 pix=(unsigned int)byte[i++];
		       decode_pixel(code,&p,pix);
		       for(yy=0;yy<32;yy++)
			 {
			    for(xx=0;xx<32;xx++)
			      {
				 c64->p[(x<<5)+xx][(y<<5)+yy].r=p.r;
				 c64->p[(x<<5)+xx][(y<<5)+yy].g=p.g;
				 c64->p[(x<<5)+xx][(y<<5)+yy].b=p.b;
			      }
			 }
		    }
	       }
	     break;
	   case FLAG_RES_1x1:
	     for (y=0;y<csize>>6;y++)
	       {
		  for(x=0;x<csize>>6;x++)
		    {
		       if (code==FLAG_PIX_24b) 
			 {
			    pix=(unsigned int)byte[i++]<<16;
			    pix|=(unsigned int)byte[i++]<<8;
			    pix|=(unsigned int)byte[i++];
			 }
		       else if ((code==FLAG_PIX_16b)||(code==FLAG_PIX_RG)||
				(code==FLAG_PIX_RB)||(code==FLAG_PIX_GB))
			 pix=(unsigned int)word[i++];
		       else
			 pix=(unsigned int)byte[i++];
		       decode_pixel(code,&p,pix);
		       for(yy=0;yy<64;yy++)
			 {
			    for(xx=0;xx<64;xx++)
			      {
				 c64->p[(x<<6)+xx][(y<<6)+yy].r=p.r;
				 c64->p[(x<<6)+xx][(y<<6)+yy].g=p.g;
				 c64->p[(x<<6)+xx][(y<<6)+yy].b=p.b;
			      }
			 }
		    }
	       }
	     break;
	   default:
	     break;
	  }
     }
   else if (csize==128)
     {
	switch(res)
	  {
	   case FLAG_RES_128x128:
	     for (y=0;y<csize;y++)
	       {
		  for(x=0;x<csize;x++)
		    {
		       if (code==FLAG_PIX_24b) 
			 {
			    pix=(unsigned int)byte[i++]<<16;
			    pix|=(unsigned int)byte[i++]<<8;
			    pix|=(unsigned int)byte[i++];
			 }
		       else if ((code==FLAG_PIX_16b)||(code==FLAG_PIX_RG)||
				(code==FLAG_PIX_RB)||(code==FLAG_PIX_GB))
			 pix=(unsigned int)word[i++];
		       else
			 pix=(unsigned int)byte[i++];
		       decode_pixel(code,&p,pix);	
		       c128->p[x][y].r=p.r;c128->p[x][y].g=p.g;c128->p[x][y].b=p.b;
		    }
	       }
	     break;
	   case FLAG_RES_64x64:
	     for (y=0;y<csize>>1;y++)
	       {
		  for(x=0;x<csize>>1;x++)
		    {
		       if (code==FLAG_PIX_24b) 
			 {
			    pix=(unsigned int)byte[i++]<<16;
			    pix|=(unsigned int)byte[i++]<<8;
			    pix|=(unsigned int)byte[i++];
			 }
		       else if ((code==FLAG_PIX_16b)||(code==FLAG_PIX_RG)||
				(code==FLAG_PIX_RB)||(code==FLAG_PIX_GB))
			 pix=(unsigned int)word[i++];
		       else
			 pix=(unsigned int)byte[i++];
		       decode_pixel(code,&p,pix);
		       for(yy=0;yy<2;yy++)
			 {
			    for(xx=0;xx<2;xx++)
			      {
				 c128->p[(x<<1)+xx][(y<<1)+yy].r=p.r;
				 c128->p[(x<<1)+xx][(y<<1)+yy].g=p.g;
				 c128->p[(x<<1)+xx][(y<<1)+yy].b=p.b;
			      }
			 }
		    }
	       }
	     break;
	   case FLAG_RES_32x32:
	     for (y=0;y<csize>>2;y++)
	       {
		  for(x=0;x<csize>>2;x++)
		    {
		       if (code==FLAG_PIX_24b) 
			 {
			    pix=(unsigned int)byte[i++]<<16;
			    pix|=(unsigned int)byte[i++]<<8;
			    pix|=(unsigned int)byte[i++];
			 }
		       else if ((code==FLAG_PIX_16b)||(code==FLAG_PIX_RG)||
				(code==FLAG_PIX_RB)||(code==FLAG_PIX_GB))
			 pix=(unsigned int)word[i++];
		       else
			 pix=(unsigned int)byte[i++];
		       decode_pixel(code,&p,pix);
		       for(yy=0;yy<4;yy++)
			 {
			    for(xx=0;xx<4;xx++)
			      {
				 c128->p[(x<<2)+xx][(y<<2)+yy].r=p.r;
				 c128->p[(x<<2)+xx][(y<<2)+yy].g=p.g;
				 c128->p[(x<<2)+xx][(y<<2)+yy].b=p.b;
			      }
			 }
		    }
	       }
	     break;
	   case FLAG_RES_16x16:
	     for (y=0;y<csize>>3;y++)
	       {
		  for(x=0;x<csize>>3;x++)
		    {
		       if (code==FLAG_PIX_24b) 
			 {
			    pix=(unsigned int)byte[i++]<<16;
			    pix|=(unsigned int)byte[i++]<<8;
			    pix|=(unsigned int)byte[i++];
			 }
		       else if ((code==FLAG_PIX_16b)||(code==FLAG_PIX_RG)||
				(code==FLAG_PIX_RB)||(code==FLAG_PIX_GB))
			 pix=(unsigned int)word[i++];
		       else
			 pix=(unsigned int)byte[i++];
		       decode_pixel(code,&p,pix);
		       for(yy=0;yy<8;yy++)
			 {
			    for(xx=0;xx<8;xx++)
			      {
				 c128->p[(x<<3)+xx][(y<<3)+yy].r=p.r;
				 c128->p[(x<<3)+xx][(y<<3)+yy].g=p.g;
				 c128->p[(x<<3)+xx][(y<<3)+yy].b=p.b;
			      }
			 }
		    }
	       }
	     break;
	   case FLAG_RES_8x8:
	     for (y=0;y<csize>>4;y++)
	       {
		  for(x=0;x<csize>>4;x++)
		    {
		       if (code==FLAG_PIX_24b) 
			 {
			    pix=(unsigned int)byte[i++]<<16;
			    pix|=(unsigned int)byte[i++]<<8;
			    pix|=(unsigned int)byte[i++];
			 }
		       else if ((code==FLAG_PIX_16b)||(code==FLAG_PIX_RG)||
				(code==FLAG_PIX_RB)||(code==FLAG_PIX_GB))
			 pix=(unsigned int)word[i++];
		       else
			 pix=(unsigned int)byte[i++];
		       decode_pixel(code,&p,pix);
		       for(yy=0;yy<16;yy++)
			 {
			    for(xx=0;xx<16;xx++)
			      {
				 c128->p[(x<<4)+xx][(y<<4)+yy].r=p.r;
				 c128->p[(x<<4)+xx][(y<<4)+yy].g=p.g;
				 c128->p[(x<<4)+xx][(y<<4)+yy].b=p.b;
			      }
			 }
		    }
	       }
	     break;
	   case FLAG_RES_4x4:
	     for (y=0;y<csize>>5;y++)
	       {
		  for(x=0;x<csize>>5;x++)
		    {
		       if (code==FLAG_PIX_24b) 
			 {
			    pix=(unsigned int)byte[i++]<<16;
			    pix|=(unsigned int)byte[i++]<<8;
			    pix|=(unsigned int)byte[i++];
			 }
		       else if ((code==FLAG_PIX_16b)||(code==FLAG_PIX_RG)||
				(code==FLAG_PIX_RB)||(code==FLAG_PIX_GB))
			 pix=(unsigned int)word[i++];
		       else
			 pix=(unsigned int)byte[i++];
		       decode_pixel(code,&p,pix);
		       for(yy=0;yy<32;yy++)
			 {
			    for(xx=0;xx<32;xx++)
			      {
				 c128->p[(x<<5)+xx][(y<<5)+yy].r=p.r;
				 c128->p[(x<<5)+xx][(y<<5)+yy].g=p.g;
				 c128->p[(x<<5)+xx][(y<<5)+yy].b=p.b;
			      }
			 }
		    }
	       }
	     break;
	   case FLAG_RES_2x2:
	     for (y=0;y<csize>>6;y++)
	       {
		  for(x=0;x<csize>>6;x++)
		    {
		       if (code==FLAG_PIX_24b) 
			 {
			    pix=(unsigned int)byte[i++]<<16;
			    pix|=(unsigned int)byte[i++]<<8;
			    pix|=(unsigned int)byte[i++];
			 }
		       else if ((code==FLAG_PIX_16b)||(code==FLAG_PIX_RG)||
				(code==FLAG_PIX_RB)||(code==FLAG_PIX_GB))
			 pix=(unsigned int)word[i++];
		       else
			 pix=(unsigned int)byte[i++];
		       decode_pixel(code,&p,pix);
		       for(yy=0;yy<64;yy++)
			 {
			    for(xx=0;xx<64;xx++)
			      {
				 c128->p[(x<<6)+xx][(y<<6)+yy].r=p.r;
				 c128->p[(x<<6)+xx][(y<<6)+yy].g=p.g;
				 c128->p[(x<<6)+xx][(y<<6)+yy].b=p.b;
			      }
			 }
		    }
	       }
	     break;
	   case FLAG_RES_1x1:
	     for (y=0;y<csize>>7;y++)
	       {
		  for(x=0;x<csize>>7;x++)
		    {
		       if (code==FLAG_PIX_24b) 
			 {
			    pix=(unsigned int)byte[i++]<<16;
			    pix|=(unsigned int)byte[i++]<<8;
			    pix|=(unsigned int)byte[i++];
			 }
		       else if ((code==FLAG_PIX_16b)||(code==FLAG_PIX_RG)||
				(code==FLAG_PIX_RB)||(code==FLAG_PIX_GB))
			 pix=(unsigned int)word[i++];
		       else
			 pix=(unsigned int)byte[i++];
		       decode_pixel(code,&p,pix);
		       for(yy=0;yy<128;yy++)
			 {
			    for(xx=0;xx<128;xx++)
			      {
				 c128->p[(x<<7)+xx][(y<<7)+yy].r=p.r;
				 c128->p[(x<<7)+xx][(y<<7)+yy].g=p.g;
				 c128->p[(x<<7)+xx][(y<<7)+yy].b=p.b;
			      }
			 }
		    }
	       }
	     break;
	   default:
	     break;
	  }
     }
}

void *encode_chunk(int code_type, unsigned int *size, unsigned int *loss, void *chk, int csize)
{
   Pixel24        p;
   int            res,code,pix,i,x,y,xx,yy,sz;
   unsigned char  *byte;
   unsigned short *word;
   void           *ptr;
   unsigned int   diff;
   unsigned int   r,g,b;
   int            shift,fac,facs; 
   RawChunk24_8   *c8;
   RawChunk24_16  *c16;
   RawChunk24_32  *c32;
   RawChunk24_64  *c64;
   RawChunk24_128 *c128;
   
   if      (csize==8)   c8=(RawChunk24_8 *)chk;
   else if (csize==16)  c16=(RawChunk24_16 *)chk;
   else if (csize==32)  c32=(RawChunk24_32 *)chk;
   else if (csize==64)  c64=(RawChunk24_64 *)chk;
   else if (csize==128) c128=(RawChunk24_128 *)chk;
   if      (csize==8)   shift=3;
   else if (csize==16)  shift=4;
   else if (csize==32)  shift=5;
   else if (csize==64)  shift=6;
   else if (csize==128) shift=7;   
   res=code_type&FLAG_RES_MSK;code=code_type&FLAG_PIX_MSK;
   i=0;diff=0;
   if      (res==FLAG_RES_128x128) sz=128;
   else if (res==FLAG_RES_64x64)   sz=64;
   else if (res==FLAG_RES_32x32)   sz=32;
   else if (res==FLAG_RES_16x16)   sz=16;
   else if (res==FLAG_RES_8x8)     sz=8;
   else if (res==FLAG_RES_4x4)     sz=4;
   else if (res==FLAG_RES_2x2)     sz=2;
   else if (res==FLAG_RES_1x1)     sz=1;
   fac=csize/sz;
   if (fac==1)   facs=0;
   if (fac==2)   facs=1;
   if (fac==4)   facs=2;
   if (fac==8)   facs=3;
   if (fac==16)  facs=4;
   if (fac==32)  facs=5;
   if (fac==64)  facs=6;
   if (fac==128) facs=7;
   
   if (code==FLAG_PIX_24b) 
     {	
	ptr=(void *)malloc(sz*sz*3);
	byte=(unsigned char *)ptr;
	*size=3*sz*sz;
     }
   else if ((code==FLAG_PIX_16b)||(code==FLAG_PIX_RG)||
	    (code==FLAG_PIX_RB)||(code==FLAG_PIX_GB))
     {
	ptr=(void *)malloc(sz*sz*2);
	word=(unsigned short *)ptr;
	*size=2*sz*sz;
     }
   else
     {
	ptr=(void *)malloc(sz*sz*1);
	byte=(unsigned char *)ptr;
	*size=1*sz*sz;
     }
   for (y=0;y<sz;y++)
     {
	for(x=0;x<sz;x++)
	  {
	     r=g=b=0;
	     for (yy=0;yy<fac;yy++)
	       {
		  for (xx=0;xx<fac;xx++)
		    {
		       if (csize==8)
			 {
			    r+=c8->p[(x<<facs)+xx][(y<<facs)+yy].r;
			    g+=c8->p[(x<<facs)+xx][(y<<facs)+yy].g;
			    b+=c8->p[(x<<facs)+xx][(y<<facs)+yy].b;
			 }
		       else if (csize==16)
			 {
			    r+=c16->p[(x<<facs)+xx][(y<<facs)+yy].r;
			    g+=c16->p[(x<<facs)+xx][(y<<facs)+yy].g;
			    b+=c16->p[(x<<facs)+xx][(y<<facs)+yy].b;
			 }
		       else if (csize==32)
			 {
			    r+=c32->p[(x<<facs)+xx][(y<<facs)+yy].r;
			    g+=c32->p[(x<<facs)+xx][(y<<facs)+yy].g;
			    b+=c32->p[(x<<facs)+xx][(y<<facs)+yy].b;
			 }
		       else if (csize==64)
			 {
			    r+=c64->p[(x<<facs)+xx][(y<<facs)+yy].r;
			    g+=c64->p[(x<<facs)+xx][(y<<facs)+yy].g;
			    b+=c64->p[(x<<facs)+xx][(y<<facs)+yy].b;
			 }
		       else if (csize==128)
			 {
			    r+=c128->p[(x<<facs)+xx][(y<<facs)+yy].r;
			    g+=c128->p[(x<<facs)+xx][(y<<facs)+yy].g;
			    b+=c128->p[(x<<facs)+xx][(y<<facs)+yy].b;
			 }
		    }
	       }
	     p.r=r>>(facs*2);p.g=g>>(facs*2);p.b=b>>(facs*2);
	     pix=encode_pixel(code,&p);
	     for (yy=0;yy<fac;yy++)
	       {
		  for (xx=0;xx<fac;xx++)
		    {
		       if (csize==8) diff+=encode_loss(code,pix,&c8->p[(x<<facs)+xx][(y<<facs)+yy]);
		       else if (csize==16) diff+=encode_loss(code,pix,&c16->p[(x<<facs)+xx][(y<<facs)+yy]);
		       else if (csize==32) diff+=encode_loss(code,pix,&c32->p[(x<<facs)+xx][(y<<facs)+yy]);
		       else if (csize==64) diff+=encode_loss(code,pix,&c64->p[(x<<facs)+xx][(y<<facs)+yy]);
		       else if (csize==128) diff+=encode_loss(code,pix,&c128->p[(x<<facs)+xx][(y<<facs)+yy]);
		    }
	       }
	     if (code==FLAG_PIX_24b) 
	       {
		  byte[i++]=(unsigned char)((pix>>16)&0xff);
		  byte[i++]=(unsigned char)((pix>>8)&0xff);
		  byte[i++]=(unsigned char)((pix)&0xff);
	       }
	     else if ((code==FLAG_PIX_16b)||(code==FLAG_PIX_RG)||
		      (code==FLAG_PIX_RB)||(code==FLAG_PIX_GB))
	       word[i++]=(unsigned short)pix;
	     else
	       byte[i++]=(unsigned char)pix;
	  }
     }
   *loss=diff;
   return ptr;
}

void *load_chunk_chunks_f(FILE *f, int *w, int *h, int *x, int *y, int *csize)
{
   int i,code,bpp,cd,sz;
   void *data;
   char s[10];
   unsigned char *v;
   int q;
   RawChunk24_8   *c8;
   RawChunk24_16  *c16;
   RawChunk24_32  *c32;
   RawChunk24_64  *c64;
   RawChunk24_128 *c128;
   
   if (!f) return NULL;
   fread(s,1,8,f);
   s[8]=0;
   fread(w,sizeof(unsigned int),1,f);
   fread(h,sizeof(unsigned int),1,f);
   fread(x,sizeof(unsigned int),1,f);
   fread(y,sizeof(unsigned int),1,f);
   fread(csize,sizeof(unsigned int),1,f);

   if      (*csize==8)   
     {
	c8=(RawChunk24_8 *)malloc(sizeof(RawChunk24_8)**x**y);if (!c8) return NULL;
     }
   else if (*csize==16)   
     {
	c16=(RawChunk24_16 *)malloc(sizeof(RawChunk24_16)**x**y);if (!c16) return NULL;
     }
   else if (*csize==32)   
     {
	c32=(RawChunk24_32 *)malloc(sizeof(RawChunk24_32)**x**y);if (!c32) return NULL;
     }
   else if (*csize==64)   
     {
	c64=(RawChunk24_64 *)malloc(sizeof(RawChunk24_64)**x**y);if (!c64) return NULL;
     }
   else if (*csize==128)   
     {
	c128=(RawChunk24_128 *)malloc(sizeof(RawChunk24_128)**x**y);if (!c128) return NULL;
     }
   data=(void *)malloc(128*128*3);
   if (!data)
     {
	if      (*csize==8)   free(c8);
	else if (*csize==16)  free(c16);
	else if (*csize==32)  free(c32);
	else if (*csize==64)  free(c64);
	else if (*csize==128) free(c128);
	return NULL;
     }
   for(i=0;i<*x**y;i++)
     {
	fread(&code,sizeof(unsigned int),1,f);
	cd=code&FLAG_PIX_MSK;sz=code&FLAG_RES_MSK;
	if (cd==FLAG_PIX_24b) bpp=3;
	else if ((cd==FLAG_PIX_16b)||(cd==FLAG_PIX_RG)||
		 (cd==FLAG_PIX_RB)||(cd==FLAG_PIX_GB)) bpp=2;
	else bpp=1;
	if      (sz==FLAG_RES_128x128) bpp*=128*128;
	else if (sz==FLAG_RES_64x64)   bpp*=64*64;
	else if (sz==FLAG_RES_32x32)   bpp*=32*32;
	else if (sz==FLAG_RES_16x16)   bpp*=16*16;
	else if (sz==FLAG_RES_8x8)     bpp*=8*8;
	else if (sz==FLAG_RES_4x4)     bpp*=4*4;
	else if (sz==FLAG_RES_2x2)     bpp*=2*2;
	fread(data,bpp,1,f);
	if      (*csize==8)   decode_chunk(code,data,&c8[i],*csize);
	else if (*csize==16)  decode_chunk(code,data,&c16[i],*csize);
	else if (*csize==32)  decode_chunk(code,data,&c32[i],*csize);
	else if (*csize==64)  decode_chunk(code,data,&c64[i],*csize);
	else if (*csize==128) decode_chunk(code,data,&c128[i],*csize);
     }
   free(data);
   if      (*csize==8)   return (void *)c8;
   else if (*csize==16)  return (void *)c16;
   else if (*csize==32)  return (void *)c32;
   else if (*csize==64)  return (void *)c64;
   else if (*csize==128) return (void *)c128;
}

int load_chunks_frame_f(FILE *f, int *w, int *h, int *x, int *y, void *chk, int csize)
{
   int i,code,bpp,cd,sz;
   void *data;
   RawChunk24_8   *c8;
   RawChunk24_16  *c16;
   RawChunk24_32  *c32;
   RawChunk24_64  *c64;
   RawChunk24_128 *c128;
   
   if      (csize==8)   c8=(RawChunk24_8 *)chk;
   else if (csize==16)  c16=(RawChunk24_16 *)chk;
   else if (csize==32)  c32=(RawChunk24_32 *)chk;
   else if (csize==64)  c64=(RawChunk24_64 *)chk;
   else if (csize==128) c128=(RawChunk24_128 *)chk;
   data=(void *)malloc(128*128*3);
   if (!data) return 0;
   if (!fread(&code,sizeof(unsigned int),1,f)) return -1;
   if (code==0xffffffff) 
     {
	free(data);
	return 0;
     }
   if (code==0xfffffffe) 
     {
	free(data);
	return -2;
     }
   cd=code&FLAG_PIX_MSK;sz=code&FLAG_RES_MSK;
   if (cd==FLAG_PIX_24b) bpp=3;
   else if ((cd==FLAG_PIX_16b)||(cd==FLAG_PIX_RG)||
	    (cd==FLAG_PIX_RB)||(cd==FLAG_PIX_GB)) bpp=2;
   else bpp=1;
   if      (sz==FLAG_RES_128x128) bpp*=128*128;
   else if (sz==FLAG_RES_64x64)   bpp*=64*64;
   else if (sz==FLAG_RES_32x32)   bpp*=32*32;
   else if (sz==FLAG_RES_16x16)   bpp*=16*16;
   else if (sz==FLAG_RES_8x8)     bpp*=8*8;
   else if (sz==FLAG_RES_4x4)     bpp*=4*4;
   else if (sz==FLAG_RES_2x2)     bpp*=2*2;
   if (!fread(data,bpp,1,f)) 
     {
	free(data);
	fprintf(stderr,"eof\n");
	return -1;
     }
   i=code>>7;
   if      (csize==8)   decode_chunk(code,data,&c8[i],csize);
   else if (csize==16)  decode_chunk(code,data,&c16[i],csize);
   else if (csize==32)  decode_chunk(code,data,&c32[i],csize);
   else if (csize==64)  decode_chunk(code,data,&c64[i],csize);
   else if (csize==128) decode_chunk(code,data,&c128[i],csize);
   free(data);
   return i+1;
}

void *load_chunks_chunks(char *file, int *w, int *h, int *x, int *y, int *csize)
{
   FILE *f;
   void *c;
   
   f=fopen(file,"r");
   if (!f) return NULL;
   c=load_chunk_chunks_f(f,w,h,x,y,csize);
   fclose(f);
   return c;
}

void *load_ppm_chunks(char *file, int *w, int *h, int *x, int *y, int csize)
{
   unsigned char *data;
   FILE *f;
   char s[1024];
   char ss[1024];
   void *c;
   
   sprintf(s,"convert %s pnm:-",file);
   f=popen(s,"r");
   if (!f) return NULL;
   fgets(s,1024,f);
   sscanf(s,"%s",ss);
   if (strcmp("P6",ss)) 
     {
	pclose(f);
	return NULL;
     }
   fgets(s,1024,f);
   while (s[0]=='#') fgets(s,1024,f);
   sleep(1);
   sscanf(s,"%i %i",w,h);
   fgets(s,1024,f);
   data=(unsigned char *)malloc(*w**h*3);
   if (!data)
     {
	pclose(f);
	return NULL;
     }
   fread(data,1,*w**h*3,f);
   pclose(f);
   c=chunkify(*w,*h,data,x,y,csize);
   free(data);
   return c;
}

void *get_best_chunk(void *cc, int *code, int maxloss, int *size, int csize)
{
   struct _chunk
     {
	int size;
	int loss;
	int code;
	void *data;
     } ch[128];
   int sz,cd,i,siz,cod;
   void *data;
   int sorted;
   int a,b,c;
   void *d;
   int cs,num;
   
   if      (csize==8)   cs=4;
   else if (csize==16)  cs=3;
   else if (csize==32)  cs=2;
   else if (csize==64)  cs=1;
   else if (csize==128) cs=0;
   sz=0;cd=0;num=0;
   for (i=0;i<128;i++)
     {
	if (sz>=cs)
	  {
	     cod=cd<<3;
	     ch[num].data=encode_chunk(cod|sz,&ch[num].size,&ch[num].loss,cc,csize);
	     if (ch[num].loss<=maxloss)
	       {
		  ch[num++].code=cod|sz;
	       }
	     else
	       free (ch[num].data);
	  }
	cd++;
	if(cd>15) 
	  {
	     cd=0;sz++;
	  }
     }
   sorted=0;
   while(!sorted)
     {
	sorted=1;
	for (i=0;i<num-1;i++)
	  {
	     if (ch[i].size==ch[i+1].size)
	       {
		  if (ch[i].loss<ch[i+1].loss)
		    {
		       sorted=0;
		       a=ch[i].size;
		       b=ch[i].loss;
		       c=ch[i].code;
		       d=ch[i].data;
		       ch[i].size=ch[i+1].size;
		       ch[i].loss=ch[i+1].loss;
		       ch[i].code=ch[i+1].code;
		       ch[i].data=ch[i+1].data;
		       ch[i+1].size=a;
		       ch[i+1].loss=b;
		       ch[i+1].code=c;
		       ch[i+1].data=d;
		    }
	       }
	  }
     }
   for (i=num-1;i>=0;i--)
     {
	if (ch[i].loss<=maxloss)
	  {
	     data=ch[i].data;
	     ch[i].data=NULL;
	     *code=ch[i].code;
	     *size=ch[i].size;
	     i=-1;
	  }
     }
   for (i=0;i<num;i++)
     {
	if (ch[i].data) free(ch[i].data);
     }
   return data;
}

void *gendelta(void *c1, void *c2, int *code, int *size, int maxloss, int maxdelta, int *loss, int csize)
{
   void *d;
   int cd;
   int x,y,diff;
   RawChunk24_8   *c1_8,*c2_8;
   RawChunk24_16  *c1_16,*c2_16;
   RawChunk24_32  *c1_32,*c2_32;
   RawChunk24_64  *c1_64,*c2_64;
   RawChunk24_128 *c1_128,*c2_128;
   
   if      (csize==8)   c1_8=(RawChunk24_8 *)c1;
   else if (csize==16)  c1_16=(RawChunk24_16 *)c1;
   else if (csize==32)  c1_32=(RawChunk24_32 *)c1;
   else if (csize==64)  c1_64=(RawChunk24_64 *)c1;
   else if (csize==128) c1_128=(RawChunk24_128 *)c1;
   if      (csize==8)   c2_8=(RawChunk24_8 *)c2;
   else if (csize==16)  c2_16=(RawChunk24_16 *)c2;
   else if (csize==32)  c2_32=(RawChunk24_32 *)c2;
   else if (csize==64)  c2_64=(RawChunk24_64 *)c2;
   else if (csize==128) c2_128=(RawChunk24_128 *)c2;
   
   diff=0;
   for (y=0;y<csize;y++)
     {
	for(x=0;x<csize;x++)
	  {
	     if (csize==8)
	       {
		  if (c2_8->p[x][y].r<c1_8->p[x][y].r) diff+=c1_8->p[x][y].r-c2_8->p[x][y].r;
		  else diff+=c2_8->p[x][y].r-c1_8->p[x][y].r;
		  if (c2_8->p[x][y].g<c1_8->p[x][y].g) diff+=c1_8->p[x][y].g-c2_8->p[x][y].g;
		  else diff+=c2_8->p[x][y].g-c1_8->p[x][y].g;
		  if (c2_8->p[x][y].b<c1_8->p[x][y].b) diff+=c1_8->p[x][y].b-c2_8->p[x][y].b;
		  else diff+=c2_8->p[x][y].b-c1_8->p[x][y].b;
	       }
	     else if (csize==16)
	       {
		  if (c2_16->p[x][y].r<c1_16->p[x][y].r) diff+=c1_16->p[x][y].r-c2_16->p[x][y].r;
		  else diff+=c2_16->p[x][y].r-c1_16->p[x][y].r;
		  if (c2_16->p[x][y].g<c1_16->p[x][y].g) diff+=c1_16->p[x][y].g-c2_16->p[x][y].g;
		  else diff+=c2_16->p[x][y].g-c1_16->p[x][y].g;
		  if (c2_16->p[x][y].b<c1_16->p[x][y].b) diff+=c1_16->p[x][y].b-c2_16->p[x][y].b;
		  else diff+=c2_16->p[x][y].b-c1_16->p[x][y].b;
	       }
	     else if (csize==32)
	       {
		  if (c2_32->p[x][y].r<c1_32->p[x][y].r) diff+=c1_32->p[x][y].r-c2_32->p[x][y].r;
		  else diff+=c2_32->p[x][y].r-c1_32->p[x][y].r;
		  if (c2_32->p[x][y].g<c1_32->p[x][y].g) diff+=c1_32->p[x][y].g-c2_32->p[x][y].g;
		  else diff+=c2_32->p[x][y].g-c1_32->p[x][y].g;
		  if (c2_32->p[x][y].b<c1_32->p[x][y].b) diff+=c1_32->p[x][y].b-c2_32->p[x][y].b;
		  else diff+=c2_32->p[x][y].b-c1_32->p[x][y].b;
	       }
	     else if (csize==64)
	       {
		  if (c2_64->p[x][y].r<c1_64->p[x][y].r) diff+=c1_64->p[x][y].r-c2_64->p[x][y].r;
		  else diff+=c2_64->p[x][y].r-c1_64->p[x][y].r;
		  if (c2_64->p[x][y].g<c1_64->p[x][y].g) diff+=c1_64->p[x][y].g-c2_64->p[x][y].g;
		  else diff+=c2_64->p[x][y].g-c1_64->p[x][y].g;
		  if (c2_64->p[x][y].b<c1_64->p[x][y].b) diff+=c1_64->p[x][y].b-c2_64->p[x][y].b;
		  else diff+=c2_64->p[x][y].b-c1_64->p[x][y].b;
	       }
	     else if (csize==128)
	       {
		  if (c2_128->p[x][y].r<c1_128->p[x][y].r) diff+=c1_128->p[x][y].r-c2_128->p[x][y].r;
		  else diff+=c2_128->p[x][y].r-c1_128->p[x][y].r;
		  if (c2_128->p[x][y].g<c1_128->p[x][y].g) diff+=c1_128->p[x][y].g-c2_128->p[x][y].g;
		  else diff+=c2_128->p[x][y].g-c1_128->p[x][y].g;
		  if (c2_128->p[x][y].b<c1_128->p[x][y].b) diff+=c1_128->p[x][y].b-c2_128->p[x][y].b;
		  else diff+=c2_128->p[x][y].b-c1_128->p[x][y].b;
	       }
	  }
     }
   if (diff>=maxdelta) 
     {
	d=get_best_chunk(c2,&cd,maxloss,size,csize);
	if (!d) return NULL;
	decode_chunk(cd,d,c2,csize);
	diff=0;
	for (y=0;y<csize;y++)
	  {
	     for(x=0;x<csize;x++)
	       {
		  if (csize==8)
		    {
		       if (c2_8->p[x][y].r<c1_8->p[x][y].r) diff+=c1_8->p[x][y].r-c2_8->p[x][y].r;
		       else diff+=c2_8->p[x][y].r-c1_8->p[x][y].r;
		       if (c2_8->p[x][y].g<c1_8->p[x][y].g) diff+=c1_8->p[x][y].g-c2_8->p[x][y].g;
		       else diff+=c2_8->p[x][y].g-c1_8->p[x][y].g;
		       if (c2_8->p[x][y].b<c1_8->p[x][y].b) diff+=c1_8->p[x][y].b-c2_8->p[x][y].b;
		       else diff+=c2_8->p[x][y].b-c1_8->p[x][y].b;
		    }
		  else if (csize==16)
		    {
		       if (c2_16->p[x][y].r<c1_16->p[x][y].r) diff+=c1_16->p[x][y].r-c2_16->p[x][y].r;
		       else diff+=c2_16->p[x][y].r-c1_16->p[x][y].r;
		       if (c2_16->p[x][y].g<c1_16->p[x][y].g) diff+=c1_16->p[x][y].g-c2_16->p[x][y].g;
		       else diff+=c2_16->p[x][y].g-c1_16->p[x][y].g;
		       if (c2_16->p[x][y].b<c1_16->p[x][y].b) diff+=c1_16->p[x][y].b-c2_16->p[x][y].b;
		       else diff+=c2_16->p[x][y].b-c1_16->p[x][y].b;
		    }
		  else if (csize==32)
		    {
		       if (c2_32->p[x][y].r<c1_32->p[x][y].r) diff+=c1_32->p[x][y].r-c2_32->p[x][y].r;
		       else diff+=c2_32->p[x][y].r-c1_32->p[x][y].r;
		       if (c2_32->p[x][y].g<c1_32->p[x][y].g) diff+=c1_32->p[x][y].g-c2_32->p[x][y].g;
		       else diff+=c2_32->p[x][y].g-c1_32->p[x][y].g;
		       if (c2_32->p[x][y].b<c1_32->p[x][y].b) diff+=c1_32->p[x][y].b-c2_32->p[x][y].b;
		       else diff+=c2_32->p[x][y].b-c1_32->p[x][y].b;
		    }
		  else if (csize==64)
		    {
		       if (c2_64->p[x][y].r<c1_64->p[x][y].r) diff+=c1_64->p[x][y].r-c2_64->p[x][y].r;
		       else diff+=c2_64->p[x][y].r-c1_64->p[x][y].r;
		       if (c2_64->p[x][y].g<c1_64->p[x][y].g) diff+=c1_64->p[x][y].g-c2_64->p[x][y].g;
		       else diff+=c2_64->p[x][y].g-c1_64->p[x][y].g;
		       if (c2_64->p[x][y].b<c1_64->p[x][y].b) diff+=c1_64->p[x][y].b-c2_64->p[x][y].b;
		       else diff+=c2_64->p[x][y].b-c1_64->p[x][y].b;
		    }
		  else if (csize==128)
		    {
		       if (c2_128->p[x][y].r<c1_128->p[x][y].r) diff+=c1_128->p[x][y].r-c2_128->p[x][y].r;
		       else diff+=c2_128->p[x][y].r-c1_128->p[x][y].r;
		       if (c2_128->p[x][y].g<c1_128->p[x][y].g) diff+=c1_128->p[x][y].g-c2_128->p[x][y].g;
		       else diff+=c2_128->p[x][y].g-c1_128->p[x][y].g;
		       if (c2_128->p[x][y].b<c1_128->p[x][y].b) diff+=c1_128->p[x][y].b-c2_128->p[x][y].b;
		       else diff+=c2_128->p[x][y].b-c1_128->p[x][y].b;
		    }
	       }
	  }
	if (diff>=maxdelta) 
	  {
	     *loss=diff;
	     *code=cd;
	     return d;
	  }
	else
	  {
	     *loss=diff;
	     free(d);
	     return NULL;
	  }
     }
   else
     {
	*loss=diff;
	return NULL;
     }
}

int main(int argc, char **argv)
{
   void *c,*c1,*c2;
   int w,h,x,y;
   int i,code,size,ii;
   void *data;
   unsigned int maxloss,maxdelta,loss;
   unsigned char *ppmdata;
   FILE *f,*ff;
   char s[1024];
   int *curloss;
   int loop;
   int csize;
   RawChunk24_8   *c8;
   RawChunk24_16  *c16;
   RawChunk24_32  *c32;
   RawChunk24_64  *c64;
   RawChunk24_128 *c128;
   RawChunk24_8   *c1_8,*c2_8;
   RawChunk24_16  *c1_16,*c2_16;
   RawChunk24_32  *c1_32,*c2_32;
   RawChunk24_64  *c1_64,*c2_64;
   RawChunk24_128 *c1_128,*c2_128;
   
   loop=1;
   if (argc>=4)
     {
	csize=atoi(argv[3]);
	maxloss=atoi(argv[1])*48*(csize/8)*(csize/8);
	maxdelta=atoi(argv[2])*48*(csize/8)*(csize/8);
	c=load_ppm_chunks(argv[4],&w,&h,&x,&y,csize);
	if      (csize==8)   c8=(RawChunk24_8 *)c;
	else if (csize==16)  c16=(RawChunk24_16 *)c;
	else if (csize==32)  c32=(RawChunk24_32 *)c;
	else if (csize==64)  c64=(RawChunk24_64 *)c;
	else if (csize==128) c128=(RawChunk24_128 *)c;
	fwrite("EANIM-01",1,8,stdout);
	fwrite(&w,sizeof(unsigned int),1,stdout);
	fwrite(&h,sizeof(unsigned int),1,stdout);
	fwrite(&x,sizeof(unsigned int),1,stdout);
	fwrite(&y,sizeof(unsigned int),1,stdout);
	fwrite(&csize,sizeof(unsigned int),1,stdout);
	curloss=(int *)malloc(sizeof(int)*x*y);
	for (i=0;i<x*y;i++)
	  {
	     curloss[i]=0;
	     if (!(i%25)) 
	       {
		  fprintf(stderr,"0: %i/%i        \r",i,x*y);
		  fflush(stderr);
	       }
	     code=0;
	     if (csize==8) 
	       {
		  data=get_best_chunk(&c8[i],&code,maxloss,&size,csize);
	       }
	     else if (csize==16) 
	       {
		  data=get_best_chunk(&c16[i],&code,maxloss,&size,csize);
	       }
	     else if (csize==32) 
	       {
		  data=get_best_chunk(&c32[i],&code,maxloss,&size,csize);
	       }
	     else if (csize==64) 
	       {
		  data=get_best_chunk(&c64[i],&code,maxloss,&size,csize);
	       }
	     else if (csize==128) 
	       {
		  data=get_best_chunk(&c128[i],&code,maxloss,&size,csize);
	       }
	     code|=i<<7;
	     fwrite(&code,sizeof(unsigned int),1,stdout);
	     fwrite(data,size,1,stdout);
	     fflush(stdout);
	     free(data);
	  }
	c1=c;
	c2=NULL;
	for(ii=5;ii<argc;ii++)
	  {
	     c2=load_ppm_chunks(argv[ii],&w,&h,&x,&y,csize);
	     if      (csize==8)   c1_8=(RawChunk24_8 *)c1;
	     else if (csize==16)  c1_16=(RawChunk24_16 *)c1;
	     else if (csize==32)  c1_32=(RawChunk24_32 *)c1;
	     else if (csize==64)  c1_64=(RawChunk24_64 *)c1;
	     else if (csize==128) c1_128=(RawChunk24_128 *)c1;
	     if      (csize==8)   c2_8=(RawChunk24_8 *)c2;
	     else if (csize==16)  c2_16=(RawChunk24_16 *)c2;
	     else if (csize==32)  c2_32=(RawChunk24_32 *)c2;
	     else if (csize==64)  c2_64=(RawChunk24_64 *)c2;
	     else if (csize==128) c2_128=(RawChunk24_128 *)c2;
	     for(i=0;i<x*y;i++)
	       {
		  code=0;
		  if (csize==8) 
		    {
		       data=gendelta(&c1_8[i],&c2_8[i],&code,&size,maxloss,maxdelta,&loss,csize);
		    }
		  else if (csize==16) 
		    {
		       data=gendelta(&c1_16[i],&c2_16[i],&code,&size,maxloss,maxdelta,&loss,csize);
		    }
		  else if (csize==32) 
		    {
		       data=gendelta(&c1_32[i],&c2_32[i],&code,&size,maxloss,maxdelta,&loss,csize);
		    }
		  else if (csize==64) 
		    {
		       data=gendelta(&c1_64[i],&c2_64[i],&code,&size,maxloss,maxdelta,&loss,csize);
		    }
		  else if (csize==128) 
		    {
		       data=gendelta(&c1_128[i],&c2_128[i],&code,&size,maxloss,maxdelta,&loss,csize);
		    }
		  if (!data) curloss[i]+=loss;
		  else curloss[i]=0;
		  if (curloss[i]>maxloss) curloss[i]=maxloss;
		  if (data)
		    {
		       code|=i<<7;
		       fwrite(&code,sizeof(unsigned int),1,stdout);
		       fwrite(data,size,1,stdout);
		       fflush(stdout);
		       free(data);
		    }
		  if (!(i%25)) 
		    {
		       fprintf(stderr,"%i: %i/%i        \r",ii-4,i,x*y);
		       fflush(stderr);
		    }
	       }
	     if ((ii==argc-1)&&(loop))
	       code=0xfffffffe;
	     else
	       code=0xffffffff;
	     fwrite(&code,sizeof(unsigned int),1,stdout);
	     fflush(stdout);
	     c=c1;c1=c2;c2=c;
	     free(c2);
	  }
     }
   else if (argc==2)
     {
	c=load_chunks_chunks(argv[1],&w,&h,&x,&y,&csize);
	fprintf(stderr,"%i x %i, %i x %i , %i\n",w,h,x,y,csize);
	ppmdata=(void *)dechunkify(w,h,x,y,c,csize);
	ff=fopen("out.ppm","w");
	fprintf(ff,"P6\n%i %i\n255\n",w,h);
	fwrite(ppmdata,(w*h*3),1,ff);
	fclose(ff);
     }
   else if (argc==3)
     {
	f=fopen(argv[1],"r");
	c=load_chunk_chunks_f(f,&w,&h,&x,&y,&csize);
	i=1;
	fprintf(stderr,"%i:     \r",i);
	fflush(stderr);
	if (i<10)
	  sprintf(s,"%s000%i.ppm",argv[2],i);
	else if (i<100)
	  sprintf(s,"%s00%i.ppm",argv[2],i);
	else if (i<1000)
	  sprintf(s,"%s0%i.ppm",argv[2],i);
	else
	  sprintf(s,"%s%i.ppm",argv[2],i);
	ff=fopen(s,"w");
	ppmdata=dechunkify(w,h,x,y,c,csize);
	fprintf(ff,"P6\n%i %i\n255\n",w,h);
	fwrite(ppmdata,(w*h*3),1,ff);
	fclose(ff);
	free(ppmdata);
	i++;
	while (1)
	  {
	     ii=load_chunks_frame_f(f,&w,&h,&x,&y,c,csize);
	     fprintf(stderr,"%i:   \r",i);
	     fflush(stderr);
	     if (ii<=0)
	       {
		  if (i<10)
		    sprintf(s,"%s000%i.ppm",argv[2],i);
		  else if (i<100)
		    sprintf(s,"%s00%i.ppm",argv[2],i);
		  else if (i<1000)
		    sprintf(s,"%s0%i.ppm",argv[2],i);
		  else
		    sprintf(s,"%s%i.ppm",argv[2],i);
		  ff=fopen(s,"w");
		  ppmdata=dechunkify(w,h,x,y,c,csize);
		  fprintf(ff,"P6\n%i %i\n255\n",w,h);
		  fwrite(ppmdata,(w*h*3),1,ff);
		  fclose(ff);
		  free(ppmdata);
		  i++;
	       }
	     if (ii==-1) break;
	     else if (ii==-2)
	       {
		  break;
	       }
	  }
	free(c);
	fclose(f);
     }
   exit(0);
}
