#include <stdio.h>
#include <signal.h>
#include <X11/Xlib.h>
#include <X11/extensions/XShm.h>
#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>
#include <math.h>
#include <ctype.h>
#include <time.h>
#include <sys/ipc.h>
#include <sys/shm.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <fcntl.h>

#define FLAG_RES_MSK 0x00000007
#define FLAG_RES_128x128 0<<0 /*Raw 1 data pixel=1x1 screen pixel*/
#define FLAG_RES_64x64   1<<0 /*Raw 1 data pixel=2x2 screen pixels*/
#define FLAG_RES_32x32   2<<0 /*Raw 1 data pixel=4x4 screen pixels*/
#define FLAG_RES_16x16   3<<0 /*Raw 1 data pixel=8x8 screen pixels*/
#define FLAG_RES_8x8     4<<0 /*Raw 1 data pixel=1x1 screen pixel*/
#define FLAG_RES_4x4     5<<0 /*Raw 1 data pixel=2x2 screen pixels*/
#define FLAG_RES_2x2     6<<0 /*Raw 1 data pixel=4x4 screen pixels*/
#define FLAG_RES_1x1     7<<0 /*Raw 1 data pixel=8x8 screen pixels*/

#define FLAG_PIX_MSK 0x00000078
#define FLAG_PIX_24b 0<<3  /*Raw 24 bit unsigned char*3 r8g8b8 delta */
#define FLAG_PIX_16b 1<<3  /*Raw 16 bit unsigned short  r5G6B5 delta */
#define FLAG_PIX_RG  2<<3  /*Raw 16 bit unsigned short  r8g8 delta */
#define FLAG_PIX_RB  3<<3  /*Raw 16 bit unsigned short  r8b8 delta */
#define FLAG_PIX_GB  4<<3  /*Raw 16 bit unsigned short  g8b8 delta */
#define FLAG_PIX_332 5<<3  /*Raw 8  bit unsigned char   r3g3b2 delta */
#define FLAG_PIX_R   6<<3  /*Raw 8  bit unsigned char   r8 delta */
#define FLAG_PIX_G   7<<3  /*Raw 8  bit unsigned char   g8 delta */
#define FLAG_PIX_B   8<<3  /*Raw 8  bit unsigned char   b8 delta */
#define FLAG_PIX_RG8 9<<3  /*Raw 8  bit unsigned char   r4g4 delta */
#define FLAG_PIX_RB8 10<<3 /*Raw 8  bit unsigned char   r4b4 delta */
#define FLAG_PIX_GB8 11<<3 /*Raw 8  bit unsigned char   g4b4 delta */
#define FLAG_PIX_GRY 12<<3 /*Raw 8  bit unsigned char   (rgb)8 delta */
#define FLAG_PIX_422 13<<3 /*Raw 8  bit unsgined char   r4g2b2 delta */
#define FLAG_PIX_242 14<<3 /*Raw 8  bit unsgined char   r2g4b2 delta */
#define FLAG_PIX_224 15<<3 /*Raw 8  bit unsgined char   r2g2b4 delta */
#define FLAG_CHUNKNO 0xffffffc0

#define AUD_NONE    0 /* no audio chunk */
#define AUD_CHUNK   1
#define AUD_STEREO  2
#define AUD_16BIT   4
#define AUD_ULAW8   8
#define AUD_UNUSED1 16
#define AUD_UNUSED2 32
#define AUD_UNUSED3 64
#define AUD_UNUSED4 128

/* anim format:
 * char "EIM 1\n";
 * char "ANIM %i %s %i %i %i %i %i" , total_byte_size, id_string, width,
 *   height, transpR, transpG, transpB;
 * int flags;
 * int chunks_x;
 * int chunks_y;
 * [possible frames];
 */
/* frame format:
 * int number_of_chunks; numnber of image chunks in this frame
 * int prev_frame_pause; length of previous frame in microseconds
 * unsigned char sound_encoding; flags for sound chunk
 * [possible sound chunk];
 * [possible image chunks];
 */
/* sound format:
 * short sample_rate;
 * unsigned char data[x];
 */
/*
 * chunk format:
 * int flags;
 * unsigned char data[X];
 */

typedef struct
{
   unsigned char r;
   unsigned char g;
   unsigned char b;
} Pixel24;

typedef struct
{
   Pixel24 p[8][8];
} RawChunk24_8;

typedef struct
{
   Pixel24 p[16][16];
} RawChunk24_16;

typedef struct
{
   Pixel24 p[32][32];
} RawChunk24_32;

typedef struct
{
   Pixel24 p[64][64];
} RawChunk24_64;

typedef struct
{
   Pixel24 p[128][128];
} RawChunk24_128;

