#include <stdio.h>
#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>
#include <math.h>
#include <ctype.h>
#include <time.h>
#include <sys/ipc.h>
#include <sys/shm.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <fcntl.h>

#define FLAG_RES_MSK 0x00000003
#define FLAG_RES_8x8 0<<0 /*Raw 1 data pixel=1x1 screen pixel*/
#define FLAG_RES_4x4 1<<0 /*Raw 1 data pixel=2x2 screen pixels*/
#define FLAG_RES_2x2 2<<0 /*Raw 1 data pixel=4x4 screen pixels*/
#define FLAG_RES_1x1 3<<0 /*Raw 1 data pixel=8x8 screen pixels*/

#define FLAG_PIX_MSK 0x0000003c
#define FLAG_PIX_24b 0<<2  /*Raw 24 bit unsigned char*3 r8g8b8 delta */
#define FLAG_PIX_16b 1<<2  /*Raw 16 bit unsigned short  r5G6B5 delta */
#define FLAG_PIX_RG  2<<2  /*Raw 16 bit unsigned short  r8g8 delta */
#define FLAG_PIX_RB  3<<2  /*Raw 16 bit unsigned short  r8b8 delta */
#define FLAG_PIX_GB  4<<2  /*Raw 16 bit unsigned short  g8b8 delta */
#define FLAG_PIX_332 5<<2  /*Raw 8  bit unsigned char   r3g3b2 delta */
#define FLAG_PIX_R   6<<2  /*Raw 8  bit unsigned char   r8 delta */
#define FLAG_PIX_G   7<<2  /*Raw 8  bit unsigned char   g8 delta */
#define FLAG_PIX_B   8<<2  /*Raw 8  bit unsigned char   b8 delta */
#define FLAG_PIX_RG8 9<<2  /*Raw 8  bit unsigned char   r4g4 delta */
#define FLAG_PIX_RB8 10<<2 /*Raw 8  bit unsigned char   r4b4 delta */
#define FLAG_PIX_GB8 11<<2 /*Raw 8  bit unsigned char   g4b4 delta */
#define FLAG_PIX_GRY 12<<2 /*Raw 8  bit unsigned char   (rgb)8 delta */
#define FLAG_PIX_422 13<<2 /*Raw 8  bit unsgined char   r4g2b2 delta */
#define FLAG_PIX_242 14<<2 /*Raw 8  bit unsgined char   r2g4b2 delta */
#define FLAG_PIX_224 15<<2 /*Raw 8  bit unsgined char   r2g2b4 delta */
#define FLAG_CHUNKNO 0xffffffe0

#define AUD_NONE    0 /* no audio chunk */
#define AUD_CHUNK   1
#define AUD_STEREO  2
#define AUD_16BIT   4
#define AUD_ULAW8   8
#define AUD_UNUSED1 16
#define AUD_UNUSED2 32
#define AUD_UNUSED3 64
#define AUD_UNUSED4 128

/* anim format:
 * char "EIM 1\n";
 * char "ANIM %i %s %i %i %i %i %i" , total_byte_size, id_string, width,
 *   height, transpR, transpG, transpB;
 * int flags;
 * int chunks_x;
 * int chunks_y;
 * [possible frames];
 */
/* frame format:
 * int number_of_chunks; numnber of image chunks in this frame
 * int prev_frame_pause; length of previous frame in microseconds
 * unsigned char sound_encoding; flags for sound chunk
 * [possible sound chunk];
 * [possible image chunks];
 */
/* sound format:
 * short sample_rate;
 * unsigned char data[x];
 */
/*
 * chunk format:
 * int flags;
 * unsigned char data[X];
 */

typedef struct
{
   unsigned char r;
   unsigned char g;
   unsigned char b;
} Pixel24;

typedef struct
{
   Pixel24 p[8][8];
} RawChunk24;

